 //*****************************************************************************
// File Name	: test.c
// 
// Title		: example usage of eduard based on servotest.c from AVRLib examples
// Revision		: 1.0
// Notes		:	
// Target MCU	: Atmel AVR 90S8535
// 
// Revision History:
// When			Who			Description of change
// -----------	-----------	-----------------------
// 10-Sep-2002	pstang		Created the program
// 20-Nov-2003   berndk       Adaption to run a robot or flash LEDs
//*****************************************************************************

 
//----- Include Files ---------------------------------------------------------
#include <avr/io.h>		// include I/O definitions (port names, pin names, etc)
#include <avr/signal.h>	// include "signal" names (interrupt names)
#include <avr/interrupt.h>	// include interrupt support

#include "global.h"		// include our global settings
#include "uart.h"		// include uart function library
#include "rprintf.h"	// include printf function library
#include "a2d.h"		// include A/D converter function library
#include "timer.h"		// include timer function library (timing, PWM, etc)
#include "servo.h"		// include RC servo driver library
#include "vt100.h"		// include VT100 terminal library

void servoTest(void);

//----- Begin Code ------------------------------------------------------------
int main(void)
{
	// initialize our libraries
	// initialize the UART (serial port)
	uartInit();
	// set the baud rate of the UART for our debug/reporting output
	uartSetBaudRate(9600);
	// set uartSendByte as the output for all rprintf statements
	rprintfInit(uartSendByte);
	// initialize the timer system
	timerInit();
	// initialize vt100 library
	vt100Init();
	vt100ClearScreen();
	// print a little intro message so we know things are working
	//rprintf("\r\nWelcome to Servo Test!\r\n");
	// turn on and initialize A/D converter
	//a2dInit();
	
	DDRA = 0x00;
	PORTA = 0x00;


	// begin servo test
	servoTest();

	return 0;
}

void servoTest(void)
{
	u08 pos;
	u08 channel;

	// do some examples
	// initialize RC servo system
	servoInit();
	// setup servo output channel-to-I/Opin mapping
	// format is servoSetChannelIO( CHANNEL#, PORT, PIN );
	servoSetChannelIO(0, _SFR_IO_ADDR(PORTC), PC4);
	servoSetChannelIO(1, _SFR_IO_ADDR(PORTC), PC5);
	servoSetChannelIO(2, _SFR_IO_ADDR(PORTC), PC2);
	servoSetChannelIO(3, _SFR_IO_ADDR(PORTC), PC3);

	// set port C pins to output
	outb(DDRC, 0x0F);

	pos = 0;


#define SPEED_SERVO	1

	// spin servos sequentially back and forth between their limits
	while(1)
	{
		//servoSetPosition(2,141);
		//servoSetPosition(3,147);

	if (1)
	{1+1;
	}//if(	a2dConvert8bit(0)>1)
	servoSetPosition(LEFT,FORWARD);        //drive forward setup
	servoSetPosition(RIGHT,BACKWARD);
	timerPause(4000);
	servoSetPosition(LEFT,FORWARD);        //right turn
	servoSetPosition(RIGHT,FORWARD);
	timerPause(500);
	outb(PORTC, 0x00);                           // comment this to get the robot running
	servoSetPosition(LEFT,FORWARD);        //drive backward setup
	servoSetPosition(RIGHT,BACKWARD);
	timerPause(4000);
	servoSetPosition(LEFT,BACKWARD);        //right turn
	servoSetPosition(RIGHT,BACKWARD);
	outb(PORTC, 0xFF);								// comment this to get the robot running
	timerPause(500);
/*
		for(channel=3; channel<SERVO_NUM_CHANNELS; channel++)
		{
			for(pos=0; pos<POSITION_MAX; pos+=10)
			{
				servoSetPosition(channel,pos);
				timerPause(SPEED_SERVO);
			}
			servoSetPosition(channel,0);
				timerPause(100);
		}

		*/
	}
}
